"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getDocumentScrollHeight() {
    var viewPortHeight = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
    var scrollHeight = document.documentElement.scrollHeight;
    var bodyScrollHeight = document.body.scrollHeight;
    if (viewPortHeight === scrollHeight && bodyScrollHeight > scrollHeight) {
        return bodyScrollHeight;
    }
    var pageHeight = 0;
    var largestNodeElement = document.querySelector('body');
    if (bodyScrollHeight === scrollHeight && bodyScrollHeight === viewPortHeight) {
        findHighestNode(document.documentElement.childNodes);
        return pageHeight + largestNodeElement.getBoundingClientRect().top;
    }
    return scrollHeight;
    function findHighestNode(nodesList) {
        for (var i = nodesList.length - 1; i >= 0; i--) {
            var currentNode = nodesList[i];
            if (currentNode.scrollHeight && currentNode.clientHeight) {
                var elHeight = Math.max(currentNode.scrollHeight, currentNode.clientHeight);
                pageHeight = Math.max(elHeight, pageHeight);
                if (elHeight === pageHeight) {
                    largestNodeElement = currentNode;
                }
            }
            if (currentNode.childNodes.length) {
                findHighestNode(currentNode.childNodes);
            }
        }
    }
}
exports.default = getDocumentScrollHeight;
//# sourceMappingURL=getDocumentScrollHeight.js.map