"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function scrollElementIntoView(element, addressBarShadowPadding) {
    var currentPosition = 0;
    var htmlNode = document.querySelector('html');
    var bodyNode = document.querySelector('body');
    if (htmlNode.scrollTop > 0) {
        currentPosition = htmlNode.scrollTop;
    }
    if (bodyNode.scrollTop > 0) {
        currentPosition = bodyNode.scrollTop;
    }
    var top = element.getBoundingClientRect().top;
    var yPosition = top - addressBarShadowPadding;
    if (htmlNode.scrollHeight > htmlNode.clientHeight) {
        htmlNode.scrollTop = yPosition;
        if (htmlNode.scrollTop === yPosition) {
            return currentPosition;
        }
    }
    if (bodyNode.scrollHeight > bodyNode.clientHeight) {
        bodyNode.scrollTop = yPosition;
        if (bodyNode.scrollTop === yPosition) {
            return currentPosition;
        }
    }
    return currentPosition;
}
exports.default = scrollElementIntoView;
//# sourceMappingURL=scrollElementIntoView.js.map