"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function setCustomCss(cssOptions) {
    if (document.head == null) {
        return;
    }
    var disableTransformationsTransitionsAnimations = "\n*, *::before, *::after {\n    -o-transition-property: none !important;\n    -moz-transition-property: none !important;\n    -ms-transition-property: none !important;\n    -webkit-transition-property: none !important;\n    transition-property: none !important;\n    -webkit-animation: none !important;\n    -moz-animation: none !important;\n    -o-animation: none !important;\n    -ms-animation: none !important;\n    animation: none !important;\n    caret-color: transparent !important;\n}";
    var addressBarPadding = cssOptions.addressBarPadding, disableCSSAnimation = cssOptions.disableCSSAnimation, id = cssOptions.id, toolBarPadding = cssOptions.toolBarPadding;
    var bodyTopPadding = addressBarPadding === 0 ? '' : "body{padding-top:".concat(addressBarPadding, "px !important}");
    var bodyBottomPadding = toolBarPadding === 0 ? '' : "body{padding-bottom:".concat(toolBarPadding, "px !important}");
    var css = (disableCSSAnimation ? disableTransformationsTransitionsAnimations : '') + bodyTopPadding + bodyBottomPadding;
    var head = document.head;
    var style = document.createElement('style');
    style.id = id;
    style.appendChild(document.createTextNode(css));
    head.appendChild(style);
}
exports.default = setCustomCss;
//# sourceMappingURL=setCustomCss.js.map