"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var hideScrollbars_1 = require("../clientSideScripts/hideScrollbars");
var removeElementFromDom_1 = require("../clientSideScripts/removeElementFromDom");
var constants_1 = require("./constants");
var utils_1 = require("./utils");
var images_1 = require("../methods/images");
var path_1 = require("path");
var hideRemoveElements_1 = require("../clientSideScripts/hideRemoveElements");
var options_interface_1 = require("./options.interface");
function afterScreenshot(executor, options) {
    return __awaiter(this, void 0, void 0, function () {
        var actualFolder, base64Image, disableCSSAnimation, fileNameOptions, filePath, hideElements, noScrollBars, isLandscape, logLevel, platformName, removeElements, path, fileName, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    actualFolder = options.actualFolder, base64Image = options.base64Image, disableCSSAnimation = options.disableCSSAnimation, fileNameOptions = options.fileName, filePath = options.filePath, hideElements = options.hideElements, noScrollBars = options.hideScrollBars, isLandscape = options.isLandscape, logLevel = options.logLevel, platformName = options.platformName, removeElements = options.removeElements;
                    path = (0, utils_1.getAndCreatePath)(actualFolder, filePath);
                    fileName = (0, utils_1.formatFileName)(fileNameOptions);
                    return [4, (0, images_1.saveBase64Image)(base64Image, (0, path_1.join)(path, fileName))];
                case 1:
                    _a.sent();
                    if (!noScrollBars) return [3, 3];
                    return [4, executor(hideScrollbars_1.default, !noScrollBars)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    if (!(hideElements.length > 0 || removeElements.length > 0)) return [3, 7];
                    _a.label = 4;
                case 4:
                    _a.trys.push([4, 6, , 7]);
                    return [4, executor(hideRemoveElements_1.default, { hide: hideElements, remove: removeElements }, false)];
                case 5:
                    _a.sent();
                    return [3, 7];
                case 6:
                    e_1 = _a.sent();
                    if (logLevel === options_interface_1.LogLevel.debug || logLevel === options_interface_1.LogLevel.warn) {
                        console.log('\x1b[33m%s\x1b[0m', "\n#####################################################################################\n WARNING:\n (One of) the elements that needed to be hidden or removed could not be found on the\n page and caused this error\n Error: ".concat(e_1, "\n We made sure the test didn't break.\n#####################################################################################\n"));
                    }
                    return [3, 7];
                case 7:
                    if (!(disableCSSAnimation || (0, utils_1.checkIsMobile)(platformName))) return [3, 9];
                    return [4, executor(removeElementFromDom_1.default, constants_1.CUSTOM_CSS_ID)];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9: return [2, {
                        devicePixelRatio: fileNameOptions.devicePixelRatio,
                        fileName: fileName,
                        isLandscape: isLandscape,
                        path: path,
                    }];
            }
        });
    });
}
exports.default = afterScreenshot;
//# sourceMappingURL=afterScreenshot.js.map