export interface AndroidOffsets {
    [key: number]: {
        STATUS_BAR: number;
        ADDRESS_BAR: number;
        TOOL_BAR: number;
    };
}
declare enum IosDeviceEnum {
    IPAD = "IPAD",
    IPHONE = "IPHONE"
}
declare enum OrientationEnum {
    LANDSCAPE = "LANDSCAPE",
    PORTRAIT = "PORTRAIT"
}
export type IosOffsets = {
    [key in IosDeviceEnum]: {
        [key: number]: {
            [key in OrientationEnum]: {
                ADDRESS_BAR: number;
                HOME_BAR: {
                    x: number;
                    y: number;
                    height: number;
                    width: number;
                };
                SAFE_AREA: number;
                STATUS_BAR: number;
            };
        };
    };
};
export {};
