import { TabbableOptions } from '../commands/tabbable.interfaces';
export interface ClassOptions {
    addressBarShadowPadding?: number;
    autoElementScroll?: boolean;
    addIOSBezelCorners?: boolean;
    autoSaveBaseline?: boolean;
    baselineFolder?: any;
    clearRuntimeFolder?: boolean;
    formatImageName?: string;
    isHybridApp?: boolean;
    logLevel?: LogLevel;
    savePerInstance?: boolean;
    screenshotPath?: any;
    toolBarShadowPadding?: number;
    disableCSSAnimation?: boolean;
    fullPageScrollTimeout?: number;
    hideScrollBars?: boolean;
    blockOutSideBar?: boolean;
    blockOutStatusBar?: boolean;
    blockOutToolBar?: boolean;
    ignoreAlpha?: boolean;
    ignoreAntialiasing?: boolean;
    ignoreColors?: boolean;
    ignoreLess?: boolean;
    ignoreNothing?: boolean;
    rawMisMatchPercentage?: boolean;
    returnAllCompareData?: boolean;
    saveAboveTolerance?: number;
    scaleImagesToSameSize?: boolean;
    tabbableOptions?: TabbableOptions;
}
export interface DefaultOptions {
    addressBarShadowPadding: number;
    autoElementScroll: boolean;
    addIOSBezelCorners: boolean;
    autoSaveBaseline: boolean;
    clearFolder: boolean;
    compareOptions: CompareOptions;
    disableCSSAnimation: boolean;
    formatImageName: string;
    fullPageScrollTimeout: number;
    hideScrollBars: boolean;
    isHybridApp: boolean;
    logLevel: LogLevel;
    savePerInstance: boolean;
    tabbableOptions: TabbableOptions;
    toolBarShadowPadding: number;
}
interface CompareOptions {
    blockOutSideBar: boolean;
    blockOutStatusBar: boolean;
    blockOutToolBar: boolean;
    ignoreAlpha: boolean;
    ignoreAntialiasing: boolean;
    ignoreColors: boolean;
    ignoreLess: boolean;
    ignoreNothing: boolean;
    rawMisMatchPercentage: boolean;
    returnAllCompareData: boolean;
    saveAboveTolerance: number;
    scaleImagesToSameSize: boolean;
}
export declare enum LogLevel {
    debug = "debug",
    info = "info",
    warn = "warn",
    silent = "silent"
}
export {};
