import { FormatFileNameOptions, GetAddressBarShadowPaddingOptions, GetAndCreatePathOptions, GetToolBarShadowPaddingOptions, ScreenshotSize } from './utils.interfaces';
export declare function getAndCreatePath(folder: string, options: GetAndCreatePathOptions): string;
export declare function formatFileName(options: FormatFileNameOptions): string;
export declare function checkIsMobile(platformName: string): boolean;
export declare function checkIsAndroid(platformName: string): boolean;
export declare function checkIsIos(platformName: string): boolean;
export declare function checkTestInBrowser(browserName: string): boolean;
export declare function checkTestInMobileBrowser(platformName: string, browserName: string): boolean;
export declare function checkAndroidNativeWebScreenshot(platformName: string, nativeWebscreenshot: boolean): boolean;
export declare function checkAndroidChromeDriverScreenshot(platformName: string, nativeWebScreenshot: boolean): boolean;
export declare function getAddressBarShadowPadding(options: GetAddressBarShadowPaddingOptions): number;
export declare function getToolBarShadowPadding(options: GetToolBarShadowPaddingOptions): number;
export declare function calculateDprData<T>(data: T, devicePixelRatio: number): T;
export declare function waitFor(milliseconds: number): Promise<void>;
export declare function getScreenshotSize(screenshot: string, devicePixelRation?: number): ScreenshotSize;
export declare function getIosBezelImageNames(normalizedDeviceName: string): {
    topImageName: string;
    bottomImageName: string;
};
